#!/bin/bash

user=carson
args=("$@")

arg_len=${#args[@]}

if [ "$arg_len" -lt "2" ]; then
    echo "Must pass serial number as argument #1 and device type as argument #2"
    exit -1
fi

serial=${args[0]}
device=${args[1]}

if [[ $device != "3010" && $device != "amp" ]]; then
    echo "Invalid device name must be 3010 or amp"
    exit -1
fi

bad_ip=true

while [[ $bad_ip == true ]]; do
    echo -n "Plese enter the IP address of the $device : "
    read cp_ip
    echo -n "Please confirm the IP address: "
    read cp_ip_confirm

    fmt=`echo $cp_ip | grep -Eo '^[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}$'`

    if [[ "$cp_ip" != "$cp_ip_confirm" ]]; then
        echo "IP addresses do not match, please try again."
        echo ""
    elif [[ "$fmt" == "" ]]; then
        echo "IP addresses must be in the form xxx.xxx.xxx.xxx, please try again."
        echo ""
    else
        bad_ip=false
    fi
done

echo ""

bad_ip=true


rm -rf /home/$user/.ssh/known_hosts

echo "Setting serial number of the Preamplifier..."
sshpass -p 9pwStVmptc8cLcgZ ssh -oStrictHostKeyChecking=no root@$cp_ip -p4422 "mount -o remount,rw / && hostname $device-$serial && echo \"$device-$serial\" > /etc/hostname && sync"

return_code=$?

if [[ $return_code != 0 ]]; then
    echo "Unable to set serial number of Control Point: $return_code"
    echo "Aborting."
    exit $return_code
fi

echo ""
echo "Done!"
echo ""


echo "New serial number:        $serial"
echo ""
echo ""

exit 0

