--  <prjroot>/base/contextbase.lua

--[[    ContextBase     Base Class

Manages the initialization, visibility and exit of on-screen
DrawRegion-derived class instances within a specific user context. 
--]]

require("context")
require("class")

ContextBase = class(function(a, id, isCurrent, icon_region, icon_strs, button_commands, region)
                        
                        a.id = id
                        a.isCurrent = isCurrent
                        
                        a.drawRegions = {}
                        --if icon_region ~= nil then
                        --    table.insert(a.drawRegions, icon_region)
                        --end
                        if region ~= nil then
                            table.insert(a.drawRegions, region)
                        end

                        a.icon_region = icon_region
                        a.icon_strs = icon_strs
                        a.button_commands = button_commands
                    end
)

function ContextBase:OnEnter()
    for kk, drawregion in pairs(self.drawRegions) do
        drawregion:OnEnter()
    end
    Log("Entering " .. contextEnumList[self.id + 1] .. " context")

end

function ContextBase:Draw(data, upnp)
    if self.icon_region ~= nil then
        self.icon_region:Draw(data, upnp)
    end
    for k, drawregion in pairs(self.drawRegions) do
        drawregion:Draw(data, upnp)
        drawregion.forceRedraw = false
    end
end

function ContextBase:OnExit(data)

    for kk, drawregion in pairs(self.drawRegions) do
        drawregion:OnExit(data)
    end

    Log("Closing " .. contextEnumList[self.id + 1] .. " context")

end
