--  IconRegion          Class

require ("base.drawregion")

--  Global constants

iconSizeHeight = 68
iconSizeWidth  = 79

IconRegion =    class(DrawRegion,
                        function(
                            a, name, 
                            frameWidth, frameHeight, 
                            frameLeftXpos, frameTopYpos,
                            isVisible,
                            iconID)

                            DrawRegion.init(
                                a, name,
                                frameWidth, frameHeight, 
                                frameLeftXpos, frameTopYpos,
                                isVisible)

                            a.iconID =          iconID
                        end)

function IconRegion:Draw()
    local   drawnIcon = Display.AcquireImage(self.iconID)

    local   frameRect =     
                SDL.newRect(
                    self.frameLeftXpos, 
                    self.frameTopYpos,
                    self.frameWidth, self.frameHeight)

    local   clipRect =      
                SDL.newRect(
                    (self.frameLeftXpos - self.boundLeftXpos),
                    (self.frameTopYpos - self.boundTopYpos),
                    iconSizeWidth, iconSizeHeight)

    SDL.BlitSurface(drawnIcon, 
                    clipRect, 
                    screen, 
                    frameRect)

end
