--[[

Rectangle       Base class for rectangular visible Region
                
                Includes Draw method

--]]

require( "class" )
require( "base.region" )

Rectangle =     class( Region, 
                    function( 
                        a, name,
                        frameWidth, frameHeight, 
                        frameLeftXpos, frameTopYpos, 
                        color, isFilled,
                        isVisible )

                        Region.init( 
                            a, name,
                            frameWidth, frameHeight, 
                            frameLeftXpos, frameTopYpos )
 
                        a.color = color
                        a.isFilled = isFilled
                        a.isVisible = isVisible
                    end )

function
    Rectangle:Draw()

    if      self.isFilled 
        then

        Display.DrawRectangleFilled(
            self.frameLeftXpos,
            self.frameTopYpos,
            self.frameWidth,
            self.frameHeight,
            self.color )

    else

        Display.DrawRectangle(
            self.frameLeftXpos,
            self.frameTopYpos,
            self.frameWidth,
            self.frameHeight,
            self.color )
    end

end

function
    Rectangle:DrawOutlined(colorOutline)

    if  not self.isFilled
        then
            LogLevel( LogLevels.WARN, 
                "DrawOutlined() called on unfilled Rectangle, assuming fill = black")
            self.color = black
    end

        Display.DrawRectangleFilled(
            self.frameLeftXpos,
            self.frameTopYpos,
            self.frameWidth,
            self.frameHeight,
            self.color )

         Display.DrawRectangle(
            self.frameLeftXpos,
            self.frameTopYpos,
            self.frameWidth,
            self.frameHeight,
            colorOutline )
     
end
