
require("draw.softtextpanel")
require("base.iconregion")
require("commands")

NUM_BUTTONS = 15

main_icon_strs = { "INPUT", "INPUT", "INPUT", "INPUT", "INPUT", "INPUT", "Soft", "Mute", "Display", "Mute Output 1",
                   "Mute Output 2", "Mute Output 3", "Option", "Setup", "Power" }

main_commands = { }
main_commands[1] = CmdSwitchInput
main_commands[2] = CmdSwitchInput
main_commands[3] = CmdSwitchInput
main_commands[4] = CmdSwitchInput
main_commands[5] = CmdSwitchInput
main_commands[6] = CmdSwitchInput
main_commands[7] = CmdSoft
main_commands[8] = CmdMute
main_commands[9] = CmdPopup
main_commands[10] = CmdOutputMute
main_commands[11] = CmdOutputMute
main_commands[12] = CmdOutputMute
main_commands[13] = CmdSwitchButtons
main_commands[14] = CmdSwitchButtons
main_commands[15] = CmdPowerOff

if #main_icon_strs ~= NUM_BUTTONS then
    LogLevel(LogLevels.ERR"Wrong number of main icon strings!")
end

if #main_commands ~= NUM_BUTTONS then
    LogLevel(LogLevels.ERR, "Wrong number of main commands!")
end

main_icons = SoftTextPanel("main_icons", screen_width,
                           screen_height - iconSizeHeight,
                           0, screen_height - iconSizeHeight - 1,
                           true, NUM_BUTTONS,
                           main_icon_strs)

option_commands = { }
option_commands[1] = CmdSwitchInput
option_commands[2] = CmdSwitchInput
option_commands[3] = CmdSwitchInput
option_commands[4] = CmdSwitchInput
option_commands[5] = CmdSwitchInput
option_commands[6] = CmdSwitchInput
option_commands[7] = CmdAuxSelect
option_commands[8] = CmdMute
option_commands[9] = CmdPopup
option_commands[10] = CmdPolarity
option_commands[11] = CmdPolarity
option_commands[12] = CmdPolarity
option_commands[13] = CmdSwitchButtons
option_commands[14] = CmdPolarity
option_commands[15] = CmdPolarity

option_icon_strs = { "INPUT", "INPUT", "INPUT", "INPUT", "INPUT", "INPUT", "Aux Select", "Mute",
                     "Display", "Polarity Output 1", "Polarity Output 2", "Polarity Output 3",
                     "Return to Home", "Polarity Absolute", "Polarity Right Channel" }

if #option_icon_strs ~= NUM_BUTTONS then
    LogLevel(LogLevels.ERR, "Wrong number of option icon strings!")
end

if #option_commands ~= NUM_BUTTONS then
    LogLevel(LogLevels.ERR, "Wrong number of option commands!")
end

option_icons = SoftTextPanel("option_icons", screen_width,
                             screen_height - iconSizeHeight,
                             0, screen_height - iconSizeHeight - 1,
                             true, NUM_BUTTONS,
                             option_icon_strs)

setup_commands = { }
setup_commands[1] = CmdDummy
setup_commands[2] = CmdPopup
setup_commands[3] = CmdPopup
setup_commands[4] = CmdPopup
setup_commands[5] = CmdPopup
setup_commands[6] = CmdPopup
setup_commands[7] = CmdPopup
setup_commands[8] = CmdMute
setup_commands[9] = CmdPopup
setup_commands[10] = CmdPopup
setup_commands[11] = CmdDummy
setup_commands[12] = CmdPopup
setup_commands[13] = CmdPopup
setup_commands[14] = CmdSwitchButtons
setup_commands[15] = CmdPopup

setup_icon_strs = { " ", "Input Balance/ Polarity", "Input Theater/ Record", "Input Off",
                    "Aux Settings", "Aux Off", "Soft Level", "Mute", "Output Polarity",
                    "Volume Scale/ Resolut.", " ", "Volume Default/ Max",
                    "System Info", "Return to Home", "Restore Factory Defaults" }

if #setup_icon_strs ~= NUM_BUTTONS then
    LogLevel(LogLevels.ERR, "Wrong number of setup icon strings!")
end

if #setup_commands ~= NUM_BUTTONS then
    LogLevels(LogLevels.ERR, "Wrong number of setup commands!")
end

setup_icons = SoftTextPanel("setup_icons", screen_width,
                            screen_height - iconSizeHeight,
                            0, screen_height - iconSizeHeight - 1,
                            true, NUM_BUTTONS,
                            setup_icon_strs)

aux_select_commands = { }
aux_select_commands[1] = CmdAuxSelectInput
aux_select_commands[2] = CmdAuxSelectInput
aux_select_commands[3] = CmdAuxSelectInput
aux_select_commands[4] = CmdAuxSelectInput
aux_select_commands[5] = CmdAuxSelectInput
aux_select_commands[6] = CmdAuxSelectInput
aux_select_commands[7] = CmdAuxSelectInput
aux_select_commands[8] = CmdDummy
aux_select_commands[9] = CmdDummy
aux_select_commands[10] = CmdDummy
aux_select_commands[11] = CmdDummy
aux_select_commands[12] = CmdDummy
aux_select_commands[13] = CmdDummy
aux_select_commands[14] = CmdDummy
aux_select_commands[15] = CmdDummy

aux_select_icon_strs = { "INPUT", "INPUT", "INPUT", "INPUT", "INPUT", "INPUT",
                         "Cancel Aux Select", " ", " ", " ", " ", " ", " ", " ", " " }

if #aux_select_icon_strs ~= NUM_BUTTONS then
    LogLevel(LogLevels.ERR, "Wrong number of setup icon strings!")
end

if #aux_select_commands ~= NUM_BUTTONS then
    LogLevels(LogLevels.ERR, "Wrong number of setup commands!")
end

aux_select_icons = SoftTextPanel("aux_select_icons", screen_width,
                                 screen_height - iconSizeHeight,
                                 0, screen_height - iconSizeHeight - 1,
                                 true, NUM_BUTTONS,
                                 aux_select_icon_strs)

factory_default_commands = { }
factory_default_commands[1] = CmdFactoryDefaults
factory_default_commands[2] = CmdFactoryDefaults
factory_default_commands[3] = CmdDummy
factory_default_commands[4] = CmdDummy
factory_default_commands[5] = CmdDummy
factory_default_commands[6] = CmdDummy
factory_default_commands[7] = CmdDummy
factory_default_commands[8] = CmdDummy
factory_default_commands[9] = CmdDummy
factory_default_commands[10] = CmdDummy
factory_default_commands[11] = CmdDummy
factory_default_commands[12] = CmdDummy
factory_default_commands[13] = CmdDummy
factory_default_commands[14] = CmdDummy
factory_default_commands[15] = CmdPopup

factory_default_icon_strs = { "Restore",  "Cancel", " ", " ", " ", " ",
                              " ", " ", " ", " ", " ", " ", " ", " ", "Cancel" }

if #factory_default_icon_strs ~= NUM_BUTTONS then
    LogLevel(LogLevels.ERR, "Wrong number of setup icon strings!")
end

if #factory_default_commands ~= NUM_BUTTONS then
    LogLevels(LogLevels.ERR, "Wrong number of setup commands!")
end

factory_default_icons = SoftTextPanel("factory_default_icons", screen_width,
                                 screen_height - iconSizeHeight,
                                 0, screen_height - iconSizeHeight - 1,
                                 true, NUM_BUTTONS,
                                 factory_default_icon_strs)


system_info_commands = { }
system_info_commands[1] = CmdInstallUpdate
system_info_commands[2] = CmdInstallUpdate
system_info_commands[3] = CmdDummy
system_info_commands[4] = CmdDummy
system_info_commands[5] = CmdDummy
system_info_commands[6] = CmdDummy
system_info_commands[7] = CmdDummy
system_info_commands[8] = CmdPopup
system_info_commands[9] = CmdDummy
system_info_commands[10] = CmdDummy
system_info_commands[11] = CmdDummy
system_info_commands[12] = CmdDummy
system_info_commands[13] = CmdPopup
system_info_commands[14] = CmdDummy
system_info_commands[15] = CmdDummy

system_info_icon_strs = { "Install",  "Cancel", " ", " ", " ", " ",
                          " ", "Remote Address", " ", " ", " ", " ", "Cancel", " ", " " }

if #system_info_icon_strs ~= NUM_BUTTONS then
    LogLevel(LogLevels.ERR, "Wrong number of setup icon strings!")
end

if #system_info_commands ~= NUM_BUTTONS then
    LogLevels(LogLevels.ERR, "Wrong number of setup commands!")
end

system_info_icons = SoftTextPanel("system_info_icons", screen_width,
                                 screen_height - iconSizeHeight,
                                 0, screen_height - iconSizeHeight - 1,
                                 true, NUM_BUTTONS,
                                 system_info_icon_strs)

-- popup comands are a special case... we don't actually change the soft
-- icons, so just the list of commands is enough
popup_commands = { }
popup_commands[1] = CmdPopup
popup_commands[2] = CmdPopup
popup_commands[3] = CmdPopup
popup_commands[4] = CmdPopup
popup_commands[5] = CmdPopup
popup_commands[6] = CmdPopup
popup_commands[7] = CmdPopup
popup_commands[8] = CmdPopup
popup_commands[9] = CmdPopup
popup_commands[10] = CmdPopup
popup_commands[11] = CmdPopup
popup_commands[12] = CmdPopup
popup_commands[13] = CmdPopup
popup_commands[14] = CmdPopup
popup_commands[15] = CmdPopup

if #popup_commands ~= NUM_BUTTONS then
    LogLevel(LogLevels.ERR, "Wrong number of popup commands!")
end
