
require("class")
require("base.artregion")
require("draw.rgbcolor")
require("format.volumestring")

MainViewRegion = class(DrawRegion,
                         function(a, name, frameWidth, frameHeight, frameLeftXpos, frameTopYpos, isVisible)
                             DrawRegion.init(a, name, frameWidth, frameHeight, frameLeftXpos, frameTopYpos, isVisible)
                         end
)

function MainViewRegion:Draw()

    local large_box_font_id = 49
    local small_box_font_id = 50
    local tiny_box_font_id = 51
    local small_box_volume_id = 52
    local large_box_volume_id = 53
    
    Display.FillBackground(self.frameLeftXpos, self.frameTopYpos, self.frameWidth, self.frameHeight)

    local arrow_h = Display.AcquireImage(0)
    local arrow_h_w, arrow_h_h = arrow_h:getSize()
    local arrow_v = Display.AcquireImage(1)
    local arrow_v_w, arrow_v_h = arrow_v:getSize()
    local pol = Display.AcquireImage(6)
    local pol_r = Display.AcquireImage(8)
    local pol_small = Display.AcquireImage(7)
    local pol_small_w, pol_small_h = pol_small:getSize()
    
    local x_pos = 18
    local y_pos = 35

    local title = Display.AcquireImage(5)
    SDL.BlitSurface(title, nil, screen, nil)
    
    -- input
    Display.DrawRectangleFilled(x_pos, y_pos, 220, 30, HIGHLIGHT)
    Display.DrawRectangle(x_pos, y_pos, 220, 78, CREME)
    local current_input_index = GetPreampSetting():GetCurrentInput()
    local current_input = GetPreampSetting():GetInputDevice(current_input_index)
    local input_text = nil
    local input_name = nil
    if GetPreampSetting():GetInputDisabled() then
        input_name = "OFF"
        input_text = "INPUT"
    else
        input_name = current_input.name
        input_text = "Input " .. current_input_index + 1
    end
    SingleLineText(input_text, small_box_font_id, x_pos, y_pos + 2, 220, 25, 0, "center", 0, false, false)
    SingleLineText(input_name, small_box_font_id,
                   x_pos, y_pos + 30 + 5, 220, 78 - 30 - 5 , 0, "center", 0, false, false)
    Display.DrawLine(x_pos + 221, y_pos + 10, 326, y_pos + 10, TAUPE)
    Display.DrawLine(x_pos + 221, y_pos + 11, 326, y_pos + 11, TAUPE)
    local rect = SDL.newRect(326 - arrow_h_w + 2, y_pos + 11 - (arrow_h_h / 2), arrow_h_w, arrow_h_h)
    SDL.BlitSurface(arrow_h, nil, screen, rect)
    
    x_pos = 327
    -- input trim
    Display.DrawRectangleFilled(x_pos, y_pos, 122, 30, HIGHLIGHT)
    Display.DrawRectangle(x_pos, y_pos, 122, 78, CREME)
    SingleLineText("Input Trim", small_box_font_id, x_pos, y_pos + 2, 122, 25, 0, "center", 0, false, false)
    SingleLineText(InputVolumeString(current_input.trim), small_box_volume_id,
                   x_pos, y_pos + 30 + 5, 122, 78 - 30 - 5, 0, "center", 0, false, false)
    Display.DrawLine(x_pos + 123, y_pos + 10, 533, y_pos + 10, TAUPE)
    Display.DrawLine(x_pos + 123, y_pos + 11, 533, y_pos + 11, TAUPE)
    rect = SDL.newRect(534 - arrow_h_w + 2, y_pos + 11 - (arrow_h_h / 2), arrow_h_w, arrow_h_h)
    SDL.BlitSurface(arrow_h, nil, screen, rect)
    
    x_pos = 534
    -- master volume
    Display.DrawRectangleFilled(x_pos, y_pos, 212, 40, HIGHLIGHT)
    Display.DrawRectangle(x_pos, y_pos, 212, 108, CREME)
    SingleLineText("Volume", large_box_font_id, x_pos, y_pos + 2, 212, 35, 0, "center", 0, false, false)
    Display.DrawLine(x_pos + 213, y_pos + 10, 1113 + (149 / 2), y_pos + 10, TAUPE)
    Display.DrawLine(x_pos + 213, y_pos + 11, 1113 + (149 / 2), y_pos + 11, TAUPE)
    Display.DrawLine(792 + (149 / 2), y_pos + 10, 792 + (149 / 2), 65, TAUPE)
    Display.DrawLine(793 + (149 / 2), y_pos + 10, 793 + (149 / 2), 65, TAUPE)
    rect = SDL.newRect(793 + (149 / 2) - (arrow_v_w / 2), y_pos + 14, arrow_v_w, arrow_v_h)
    SDL.BlitSurface(arrow_v, nil, screen, rect)
    Display.DrawLine(953 + (149 / 2), y_pos + 10, 953 + (149 / 2), 65, TAUPE)
    Display.DrawLine(954 + (149 / 2), y_pos + 10, 954 + (149 / 2), 65, TAUPE)
    rect = SDL.newRect(954 + (149 / 2) - (arrow_v_w / 2), y_pos + 14, arrow_v_w, arrow_v_h)
    SDL.BlitSurface(arrow_v, nil, screen, rect)
    Display.DrawLine(1113 + (149 / 2), y_pos + 10, 1113 + (149 / 2), 65, TAUPE)
    Display.DrawLine(1114 + (149 / 2), y_pos + 10, 1114 + (149 / 2), 65, TAUPE)
    rect = SDL.newRect(1114 + (149 / 2) - (arrow_v_w / 2), y_pos + 14, arrow_v_w, arrow_v_h)
    SDL.BlitSurface(arrow_v, nil, screen, rect)
    -- main polarity
    rect = SDL.newRect(x_pos + 212 - 48, y_pos + 58, 50, 35)
    local pol_offset = 0
    if GetPreampSetting():GetPolarityRight() then
        SDL.BlitSurface(pol_r, nil, screen, rect)
        pol_offset = 40
    elseif GetPreampSetting():GetPolarity() then        
        SDL.BlitSurface(pol, nil, screen, rect)
        pol_offset = 40
    end
    SingleLineText(GetPreampSetting():GetMasterVolumeString(), large_box_volume_id,
                   x_pos, y_pos + 40 + 5, 212 - pol_offset, 108 - 40 - 5, 0, "center", 0, false, false)

    x_pos = 792
    y_pos = 65
    -- output 1
    Display.DrawRectangleFilled(x_pos, y_pos, 149, 30, HIGHLIGHT)
    Display.DrawRectangle(x_pos, y_pos, 149, 78, CREME)
    local output = GetPreampSetting():GetOutputDevice(0)
    SingleLineText(output.name, small_box_font_id, x_pos, y_pos + 2, 149, 25, 0, "center", 0, false, false)
    -- output 1 polarity
    local pol_offset = 0
    rect = SDL.newRect(x_pos + 149 - pol_small_w - 8, y_pos + 42, pol_small_w, pol_small_h)    
    if output.polarity_temp then
        SDL.BlitSurface(pol_small, nil, screen, rect)
        pol_offset = 20
    end
    local vol_str = OutputVolumeString(output.volume)
    if output.mute then
        vol_str = "MUTED"
    end
    SingleLineText(vol_str, small_box_volume_id,
                   x_pos - pol_offset, y_pos + 30 + 5, 149, 78 - 30 - 5, 0, "center", 0, false, false)

    x_pos = 953
    -- output 2 
    Display.DrawRectangleFilled(x_pos, y_pos, 149, 30, HIGHLIGHT)
    Display.DrawRectangle(x_pos, y_pos, 149, 78, CREME)
    local output = GetPreampSetting():GetOutputDevice(1)
    SingleLineText(output.name, small_box_font_id, x_pos, y_pos + 2, 149, 25, 0, "center", 0, false, false)
    -- output 2 polarity
    local pol_offset = 0
    rect = SDL.newRect(x_pos + 149 - pol_small_w - 8, y_pos + 42, pol_small_w, pol_small_h)    
    if output.polarity_temp then
        SDL.BlitSurface(pol_small, nil, screen, rect)
        pol_offset = 20
    end
    local vol_str = OutputVolumeString(output.volume)
    if output.mute then
        vol_str = "MUTED"
    end
    SingleLineText(vol_str, small_box_volume_id,
                   x_pos - pol_offset, y_pos + 30 + 5, 149, 78 - 30 - 5, 0, "center", 0, false, false)

    x_pos = 1113
    -- output 3
    Display.DrawRectangleFilled(x_pos, y_pos, 149, 30, HIGHLIGHT)
    Display.DrawRectangle(x_pos, y_pos, 149, 78, CREME)
    local output = GetPreampSetting():GetOutputDevice(2)
    SingleLineText(output.name, small_box_font_id, x_pos, y_pos + 2, 149, 25, 0, "center", 0, false, false)
    -- output 3 polarity
    local pol_offset = 0
    rect = SDL.newRect(x_pos + 149 - pol_small_w - 8, y_pos + 42, pol_small_w, pol_small_h)    
    if output.polarity_temp then
        SDL.BlitSurface(pol_small, nil, screen, rect)
        pol_offset = 20
    end
    local vol_str = OutputVolumeString(output.volume)
    if output.mute then
        vol_str = "MUTED"
    end
    SingleLineText(vol_str, small_box_volume_id,
                   x_pos - pol_offset, y_pos + 30 + 5, 149, 78 - 30 - 5, 0, "center", 0, false, false)

    x_pos = 26
    y_pos = 129
    -- blend
    Display.DrawRectangleFilled(x_pos, y_pos, 102, 27, HIGHLIGHT)
    Display.DrawRectangle(x_pos, y_pos, 204, 27, CREME)
    SingleLineText("Blend", tiny_box_font_id, x_pos, y_pos + 2, 102, 27 - 2, 0, "center", 0, false, false)
    SingleLineText(GetPreampSetting():GetBlendString(GetPreampSetting():GetBlend()), tiny_box_font_id,
                   x_pos + 102, y_pos + 2, 102, 27 - 2, 0, "center", 0, false, false)

    x_pos = 284
    -- balance
    Display.DrawRectangleFilled(x_pos, y_pos, 102, 27, HIGHLIGHT)
    Display.DrawRectangle(x_pos, y_pos, 204, 27, CREME)
    SingleLineText("Balance", tiny_box_font_id, x_pos, y_pos + 2, 102, 27 - 2, 0, "center", 0, false, false)
    SingleLineText(GetPreampSetting():GetBalanceString(GetPreampSetting():GetBalance()), tiny_box_font_id,
                   x_pos + 102, y_pos + 2, 102, 27 - 2, 0, "center", 0, false, false)

    --Display.ReleaseImage(title)
    --Display.ReleaseImage(arrow_v)
    --Display.ReleaseImage(arrow_h)
    
end


main_view_region = MainViewRegion("Main View", screen_width, screen_height - iconSizeHeight, 0, 0, true)
