
require("class")
require("base.artregion")
require("draw.rgbcolor")
require("format.volumestring")

PopupViewRegion = class(DrawRegion,
                         function(a, name, frameWidth, frameHeight, frameLeftXpos, frameTopYpos, isVisible)
                             DrawRegion.init(a, name, frameWidth, frameHeight, frameLeftXpos, frameTopYpos, isVisible)
                         end
)

function PopupViewRegion:Draw()

    local offset_for_soft_icons = 0
    if current_popup == popup_list_setup[13] or current_popup == popup_list_setup[15] then
        offset_for_soft_icons = iconSizeHeight
    end
    
    local r = SDL.newRect(0, 0, screen_width, screen_height)
    local surf = SDL.CreateRGBSurface(SDL.SWSURFACE, screen_width, screen_height - offset_for_soft_icons,
                                      32, 0x000000FF, 0x0000FF00, 0x00FF0000, 0xFF000000)
    SDL.FillRect(surf, r, 0xaa000000)
    SDL.BlitSurface(surf, nil, screen, nil)
    SDL.FreeSurface(surf)
            
    if current_popup ~= nil then
        if current_popup == popup_list_setup[13] then
            -- special case drawing of sys info
            current_popup[popup_index][3]()
            
            local font_id = 55
            local x_pos = 80
            local y_pos = 20
            SingleLineText("Serial Number: " .. GetSerialNumber(), font_id, x_pos, y_pos, 800, 40, 0, "left", 0, false, false)

            y_pos = y_pos + 30
            local ip = GetPreampSetting():GetIPAddress()
            SingleLineText("IP Address: " .. ip, font_id, x_pos, y_pos, 800, 40, 0, "left", 0, false, false)
            
            y_pos = y_pos + 30
            local mac = GetPreampSetting():GetMAC()
            SingleLineText("MAC Address: " .. mac, font_id, x_pos, y_pos, 800, 40, 0, "left", 0, false, false)

            y_pos = y_pos + 30
            SingleLineText("Firmware Version: " .. GetSoftwareVersion(), font_id, x_pos, y_pos, 800, 40, 0, "left", 0, false, false)

            if GetPreampSetting():GetInternetUpdateVersion() then
                y_pos = y_pos + 30
                SingleLineText("Update Available: " .. GetPreampSetting():GetInternetUpdateVersion(),
                               font_id, x_pos, y_pos, 800, 40, 0, "left", 0, false, false)
            end
            
        elseif current_popup == popup_list_setup[15] then
            -- special case drawing of restore factory defaults
            current_popup[popup_index][3]()
            
            local font_id = 54
            local x_pos = 80
            local y_pos = 60
            SingleLineText("Restore Factory Defaults?", font_id, x_pos, y_pos, 800, 30, 0, "left", 0, false, false)
        else
            -- normal draw case
            local font_id = 54
            --print("Drawing popup: " .. current_popup[popup_index][1] .. " index " .. popup_index)
            
            local x_pos = 80
            local y_pos = 60
            Display.DrawRectangleFilled(x_pos, y_pos, 600, 120, ROAST)
            Display.DrawRectangle(x_pos + 1, y_pos + 1, 598, 118, CREME)
            SingleLineText(current_popup[popup_index][1], font_id, x_pos, y_pos + 30, 600, 60 - 30, 0, "center", 0, false, false)
            
            x_pos = screen_width - 500 - x_pos
            Display.DrawRectangleFilled(x_pos, y_pos, 500, 120, ROAST)
            Display.DrawRectangle(x_pos + 1, y_pos + 1, 498, 118, CREME)
            local str = current_popup[popup_index][2](current_popup[popup_index][3]())
            SingleLineText(str, font_id, x_pos, y_pos + 30, 500, 60 - 30, 0, "center", 0, false, false)

        end
    end
end

popup_view_region = PopupViewRegion("Popup View", screen_width, screen_height - iconSizeHeight, 0, 0, true)
