from collections import defaultdict
import time
import datetime
import platform
import os
import threading

import libpreamp_lib as amp
#import amp
from pylogger import bllogger
import functools
import traceback
import inspect

def LockCFunction(func):
    @functools.wraps(func)
    def runFunc(*args, **kwargs):
        rtn = ""
        #print "function about to take config lock %s" % func
        config = amp.GetConfigLock() 
        #print "function took config lock %s" % func
        preamp = amp.GetPreampSettingLock()
        try:
            rtn = func(*args, **kwargs)
        except Exception as e:
            tb = traceback.format_exc()
            bllogger('err', "Error encounterd in API (%r) " %func)
            bllogger('err', "%r" %tb)
        finally:
            amp.ReleasePreampSettingLock(preamp)
            #print "function about to release config lock %s" % func
            amp.ReleaseConfigLock(config)
            #print "function released config lock %s" % func
        return rtn
    return runFunc


class PreampSetting:

    def __init__(self):
        self.preamp_setting = amp.GetPreampSetting()


        self.room = self.preamp_setting.GetRoom()

        self.lock = threading.RLock()

        self.update_available = False

        self.room_table = {}



    def find_id(self):
        self.mac = self.preamp_setting.GetMAC()
        self.room_table[self.mac] = 'self'
        devices = amp.DeviceVector()
        self.preamp_setting.GetRoomDevices(devices)
        for i in range(len(devices)):
            print devices[i].deviceName
            print devices[i].deviceMAC
            self.room_table[devices[i].deviceMAC] = devices[i].deviceName
        MAC_list = self.room_table.keys()
        MAC_list.sort()
        self.id = MAC_list.index(self.mac)
        self.power_time_1 = self.id * 11 * 0.262


    def GetPowerOn(self):
        return self.preamp_setting.GetPowerOn()

    def wakeOnLan(self):
	wakeup = self.preamp_setting.GetWakeOnLan()
        bllogger('debug', 'here is the wakeup signal value: %d'%wakeup)
	if wakeup:
	    self.preamp_setting.SetWakeOnLan(False)
	return wakeup


    def power_off(self):
	pass
    def power_on(self):
	pass

    def set_room(self, room):
        bllogger('info', 'AmplifierSettings.py set_room')
        self.room = room
        print type(room)
        print 'set internal'
        self.preamp_setting.SetRoom(str(room))

    def get_update_available(self):
        #self.update_available = self.preamp_setting.CheckForUpdates() or (self.preamp_setting.GetContext()==amp.Context.UPDATE)
        return self.preamp_setting.update_ready
        #return self.update_available

    def start_update(self):
        if self.get_update_available():
            self.preamp_setting.InstallUpdate()
            return True
        else:
            return False


    def get_model_name(self):

        return self.preamp_setting.GetLeftVersion()

    def process_state(self):
       pass 
