import os
os.chdir(os.path.abspath(os.path.dirname(__file__)))
import subprocess
import platform
import sys
sys.path.append('./website')
if 'arm' in platform.machine():
    sys.path.append('./build_arm')
    PC=False
else:
    PC=True
    sys.path.append('./build')

import threading
import time 
import argparse
import logging

import pylogger
import libpreamp_lib as amp

#from key_handler import KeyHandler
#from gpio_output import GpioOutput
from preampsetting import PreampSetting
import python_settings
import main_page
import rest_api



def startup():
    main_page.app.register_blueprint(main_page.main, url_prefix='/main')
    main_page.app.register_blueprint(rest_api.api_point, url_prefix='/api')
    main_page.app.config.update(
            APPLICATION_ROOT=__file__+'/website',
            template_folder=os.path.join(os.path.dirname(os.path.abspath(__file__)),'website/template'),
            static_folder=os.path.join(os.path.dirname(os.path.abspath(__file__)),'website/static')
            )
    main_page.app.jinja_env.globals.update(blend_string=python_settings.preamp_setting.preamp_setting.GetBlendString)
    main_page.app.jinja_env.globals.update(balance_string=python_settings.preamp_setting.preamp_setting.GetBalanceString)
    main_page.app.jinja_env.globals.update(input_balance_string=python_settings.preamp_setting.preamp_setting.GetInputBalanceString)
    main_page.app.jinja_env.globals.update(scale_master_vol=python_settings.preamp_setting.preamp_setting.ScaleMasterVolume)
    main_page.app.logger.setLevel(logging.ERROR)
    log = logging.getLogger('werkzeug')
    log.setLevel(logging.ERROR)
    rest_api.init_rest_api(main_page.app)
    rest_api.register_headers(main_page.app)
    port=5000 if PC else 80
    flask_thread = threading.Thread(target=main_page.app.run, kwargs={'threaded':'True', 'host':'0.0.0.0', 'port':port})
    flask_thread.start()

    #main_page.app.run(debug=True, threaded=True, port=port, host='0.0.0.0', use_reloader=False)


if __name__ == '__main__':
    parser = argparse.ArgumentParser()
    parser.add_argument('--config', default='config',help="Name of config file to use")
    parser.add_argument('--log', default='log', help="Name of log file to use")
    args = parser.parse_args()
    try:
        global running
        pylogger.setup(args.log+'_python', 'logout')
        amp.SetupLogging(args.log)
        amp.CreateSubsystems()
        #amp.SetConfigFile(args.config)
        python_settings.init_globals()
        global amplifier_setting

        amp.StartLuaThread()

        
        print 'Done setting up services'
        amplifier_setting = python_settings.preamp_setting

        startup()
        while True:
            time.sleep(1)
    except KeyboardInterrupt:
        print "Received keyboard interupt exiting..."
        amp.StopLuaThread()
        amp.EmergencyShutdown();
        exit(0);
    
