#!/usr/bin/env python
import os
import sys
from subprocess import Popen, PIPE
os.chdir(os.path.dirname(os.path.abspath(__file__)))
def __main__():

	if len(sys.argv) < 2:
		print 'Must specify destination directory'
		sys.exit(-1)

	destdir = sys.argv[1]

	# First check if we are on a working copy or not
	p = Popen(["git", "log", "-n",  "1"], stdout=PIPE)
        ret = p.communicate()[0]
        lines = ret.split('\n')
        print "gitlog lines: ", lines
        current_hash = lines[0].split(' ')[1]

        p = Popen(["git",  "diff", "--exit-code"], stdout=PIPE)
        ret = p.communicate()[0]
        modified = p.returncode

        version = None
        if not modified:        
            p = Popen(["git", "show-ref", "--tag"], stdout=PIPE)
            ret = p.communicate()[0]
            #strip off empty string last line
            lines = ret.split('\n')[:-1]
            #print "git show-ref lines: ", lines
            for line in lines:
                print line
                hash, tag = line.split(' ')
                if 'LATEST' in tag:
                    LATEST_hash = hash
                elif hash == current_hash:
                    version = tag.strip('refs/tags/')


        if version is None:
            rev = current_hash + ('M' if modified else '')
        else:
            rev = version

        print "rev: ", rev
	output = \
	'#ifndef BLLIBS_VERSION_H\n\
	#define BLLIBS_VERSION_H\n\
	\n\
        static const char * BLLIBS_VERSION_PARTIAL_PATH = "https://github.com/BoulderLabs/amplifier.git";\n\
        static const char * BLLIBS_VERSION_FULL_PATH = "https://github.com/BoulderLabs/amplifier.git";\n\
	static const char * BLLIBS_VERSION_VERSION_RANGE = "' + rev + '";\n\
	static const char * BLLIBS_VERSION_PATH_HASH = \"\";\n\
    static const char * BLLIBS_VERSION_LAST_CHANGED_REV = \"\";\n\
    static const char * BLLIBS_VERSION_LAST_CHANGED_DATE = \"\";\n\
    static const char * BLLIBS_VERSION_BUILD_DATE = \"\";\n\
	\n\
	#endif\n'

	outfile = open(destdir + '/version.h', 'w')
	outfile.write(output)
	outfile.close()

if __name__ == '__main__':
	__main__()
