//TODO combine with other templates so I can use jinja values in some functions

var push_num = 0;

$(document).ready(function() {

    $('#amp_error_table').DataTable( {
            "paging": false,
            "info": false,
            "searching": false,
            "order": [[3, "desc" ]]
    });
    $.each($('.volume_slider'), function() {
        updateSliderNumber($(this));
    });

    $('.volume_slider').on("change mousemove input ", function(e) {
        updateSliderNumber($(this));
    });

    $('.volume_slider').on("mousedown touchstart", function() {
        $(this).addClass("user_changed");
    });

    $("form :checkbox").change(function() {
        $(this).addClass("user_changed");
    });

    $("form :text").on("focus", function() {
	$(this).addClass("user_changed");
    });


    $("form :text").on("blur", function() {
	$(this).removeClass("user_changed");
    });

    $('form').on("change submit ", function(e) {
        formSubmit($(this));
        e.preventDefault();
    });
    
    $('.input_button').on("click", function() {
        var index = $(this).attr('id');
        if (index !== "off") {
            setCurrentInput(index);
            $(this).closest('form').find('input[name=index]').val(index);
        } else {
            disableInput();
        }
        $(this).addClass("user_changed");
    });

    $('.input:radio').on("click", function() {
        console.log("radio button clicked");
    });

    $('.aux_button').on("click", function() {
        $('.current_aux').removeClass("current_aux");
        var index = $(this).attr('id');
        $('.selected').removeClass('selected');
        setCurrentAux(index);
        $(this).closest('form').find('input[name=index]').val(index);
        $(this).addClass("user_changed");
        $(this).parent().addClass("selected");
    });

    $('.standalone-btn').on("click", function() {
        $(this).closest("form").submit();
    });

});

function formSubmit(element) {
        push_num++ ;
        var postData = element.serializeArray();
        $.ajax(
            {
                url: '/ajax',
                method: 'POST',
                data: postData,
                success: function(json){
                    writing_data=false;
                    $('.user_changed').removeClass("user_changed");
                },
                
                error: function() {
                }
            });
        if (element.hasClass('resolution_form')) {
            location.reload();
        }
}

function updateSliderNumber(element) {
    var num = parseFloat(element.val()).toFixed(1);
    if(element.attr('name') === 'blend') {
        //todo expose this array from jinja
        var blend_values = ["Stereo", "-32", "-29", "-26", "-23", "-20", "-18", "-16", "-14", "-12", "-10", "-8", "-6", "-4", "-2", "Mono"];
        element.parent().find('.volume_text').text(blend_values[parseInt(num)] );
    }
    else if (element.attr('name') === "balance") {
        element.parent().find('.volume_text').text(getBalanceString(num, 201));
    }
    else if (element.attr('name') === "input_balance") {
        element.parent().find('.volume_text').text(getBalanceString(num, 121));
    }
    else if (element.attr('name') === "master_volume") {
        element.parent().find('.volume_text').text(getMasterVolumeString(element, num));
    }
    else if (element.attr('name') === "display_brightness") {
        element.parent().find('.volume_text').text(num + " %");
    }
    else {
        element.parent().find('.volume_text').text(num + " dB");
    }
}


//TODO get rid of and combine with setElement
function setSlider(slider, value) {
    if ($("input[name="+slider+"]").hasClass("user_changed")) {
        return;
    }
    var old_value = parseFloat($("input[name="+slider+"]").val()).toFixed(1);
    if (old_value !== value.toFixed(1)) {
        $("input[name="+slider+"]").val(value);
        updateSliderNumber($("input[name="+slider+"]"));
    }
};

function setCheckboxElement(element, value) {
    if (element.hasClass("user_changed")) {
        return;
    }
    if (element.prop("checked") !== value) {
        element.prop("checked", value);
    }
};


function setElement(element, value) {
    var old_value = parseFloat(element.val()).toFixed(1);
    var new_value = parseFloat(value).toFixed(1);
    if (element.hasClass("user_changed")) {
        return;
    }
    if (old_value !== new_value) {
        element.val(new_value);
        if (element.attr('type') === 'range') {
            updateSliderNumber(element);
        }
    }
};
function setTextBox(element, text) {
    if (element.hasClass("user_changed")) {
	return;
    }
    var old_value = parseFloat(element.val());
    if (old_value !== text) {
	element.val(text);
    }
}

function setInput(input_device) {
    var main_input = $("#main_input_"+input_device['index']);

    var trim = main_input.find('.volume_slider[name="trim"]')
    setElement(trim, input_device['trim']);

    var name = main_input.find('h3[name="name"]');
    name.html(input_device['name']);

    $('#input_select_name_'+input_device['index']).text(input_device['name']);    
    
    var setting_input = $("#setting_input_"+input_device['index']);

    var name = setting_input.find('input[name="name"]');
    setTextBox(name, input_device['name']);

    var balance = setting_input.find('.volume_slider[name="input_balance"]')
    setElement(balance, input_device['balance']);

    var polarity =setting_input.find('input[name="polarity"]')
    setCheckboxElement(polarity, input_device['polarity']);

    var theater_mode =setting_input.find('input[name="theater_mode"]')
    setCheckboxElement(theater_mode, input_device['theater_mode']);

    var recordable =setting_input.find('input[name="recordable"]')
    setCheckboxElement(recordable, input_device['recordable']);

};


function setOutput(output_device) {
    var main_output = $("#main_output_"+output_device['index']);

    var name = main_output.find('h3[name="name"]');
    name.html(output_device['name']);

    var volume = main_output.find('.volume_slider[name="output_volume"]')
    setElement(volume, output_device['volume']);

    var mute = main_output.find('input[name="mute"]')
    setCheckboxElement(mute, output_device['mute']);

    var output_polarity = $("#output_polarity_temp_"+output_device['index']);
    setCheckboxElement(output_polarity, output_device['polarity_temp']);

    var output_polarity_label = $("#output_polarity_temp_label_"+output_device['index']);
    output_polarity_label.html(output_device['name']);


    var polarity_label = output_polarity.find('label[name="polarity_label"]');
    setElement(polarity_label, output_device['name']);

    var output = $("#output_"+output_device['index']);
    var name = output.find('input[name="name"]')
    setTextBox(name, output_device['name']);

    var polarity = output.find('input[name="polarity"]');
    setCheckboxElement(polarity, output_device['polarity']);
};

function setTable(element, data) {
    var errorTable = $('#amp_error_table').DataTable();
    errorTable.clear();
    var newTable = []
    $.each(data, function(amp, error_info) {
        for(var error in error_info) {
            for (var index in error_info[error]) {
                var row = [ amp,
                         error.toString(),
                         error_info[error][index].count.toString(),
                         error_info[error][index].time.toString()
                ];
                errorTable.row.add(row)
                newTable.push(row);
            }
        }
    });
    //errorTable.rows.add(newTable);
    errorTable.draw(); 
    //element.find('tbody').replaceWith(newTable);

};



function UpdatePage() {
        $.ajax({
            url: '/ajax/all_data',
            type: 'GET',
            dataType: 'json',
            success:function(_push_num) { return function(json){
                if (_push_num < push_num) {
                    return;
                }
                console.log("sucessfully got a json");
                setSlider("balance", json['responses']["balance"]);
                setSlider("blend", json['responses']["blend"]);
                setSlider("master_volume", json['responses']["master_volume"]);
                setSlider("soft_level", json['responses']["soft_level"]);
                setSlider("display_brightness", json['responses']["display_brightness"]);
                 
                if (!json['responses']['input_disabled']) { 
                    for (var i =0; i < json['responses']['inputs'].length; i++) {
                        setInput(json['responses']['inputs'][i]);
                    }
                    current_input = json['responses']['current_input']
                    setCurrentInput(current_input);
                }
                else {
                   disableInput(); 
                }
                
                for (var i=0; i<json['responses']['output_device'].length; i++) {
                    setOutput(json['responses']['output_device'][i]);
                }

		var max_volume = $('[name=max_volume]');
		setTextBox(max_volume, json['responses']['max_volume']);

		var default_volume = $('[name=default_volume]');
		setTextBox(default_volume, json['responses']['default_volume']);


                if (!json['responses']['aux_disabled']) { 
                    current_aux = json['responses']['current_aux'];
                    setCurrentAux(current_aux);
                }
                else {
                    setCurrentAux('-1');
                }

                $('.mute').each(function() {
                    setCheckboxElement($(this), json['responses']['mute']);
                });

                $('.soft_mute').each(function() {
                    setCheckboxElement($(this), json['responses']['soft']);
                });

                var polarity = $('#polarity_absolute');
                setCheckboxElement(polarity, json['responses']['polarity']);

                var polarity_right = $('#polarity_right');
                setCheckboxElement(polarity_right, json['responses']['polarity_right']);

                var polarity_aux = $('#aux_polarity');
                setCheckboxElement(polarity_aux, json['responses']['polarity_aux']);

                var polarity_aux = $('#aux_follows_main');
                setCheckboxElement(polarity_aux, json['responses']['aux_follows_main']);
                
                var update_status = $('#update_status');
                setElement(update_status, json['responses']['update_status']);

                var amp_errors = $('#amp_error_table');
                setTable(amp_errors, json['responses']['amplifier_errors']);
                
                if($('.progress-bar').length) { 
                    var progress_bar = $('.progress-bar');
                    progress_bar.attr("aria-valuenow", json['responses']['update_progress']).css('width', json['responses']['update_progress']+'%');
                    progress_bar.html(json['responses']['update_progress']+'%');
                    $('#update_status').html(json['responses']['update_status'])
                }

            };}(push_num),
            error: function() {
                console.log('no json response');
            }
        });
        setTimeout(UpdatePage, 2000);
    };

function changeTab(evt, page) {
    // Declare all variables
    var i, tabcontent, tablinks;

    // Get all elements with class="tabcontent" and hide them
    tabcontent = document.getElementsByClassName("tabcontent");
    for (i = 0; i < tabcontent.length; i++) {
        tabcontent[i].style.display = "none";
    }

    // Get all elements with class="tablinks" and remove the class "active"
    tablinks = document.getElementsByClassName("tablinks");
    for (i = 0; i < tablinks.length; i++) {
        tablinks[i].className = tablinks[i].className.replace(" active", "");
    }

    // Show the current tab, and add an "active" class to the link that opened the tab
    document.getElementById(page).style.display = "block";
    evt.currentTarget.className += " active";
};
function disableInput() {
    $('.input_selected').removeClass('input_selected');
    $('.current_input').removeClass('current_input');
    $('#input_select_off').addClass('input_selected');
    $('#current_input_form').find('input[name=index]').val("-1");
};

function setCurrentInput(index){
    $('.current_input').removeClass('current_input');
    $('.input_list[name="'+index+'"]').addClass('current_input');
    $('.input_selected').removeClass('input_selected');
    $('#input_select_'+index).addClass('input_selected');
};
function setCurrentAux(index){
    $('.aux_selected').removeClass('aux_selected');
    $('#aux_select_'+index).addClass('aux_selected');
};

//This should mirror the GetBalance function in preampsettings.cpp
function getBalanceString(balance, limit) {
    var value = parseInt(balance*10);
    var balance_string = "";
    if(value === -limit) 
    {
        balance_string += "R MUTED";
    }
    else if(value === limit) 
    {
        balance_string += "L MUTED";
    }
    else if(value < 0) 
    {
        balance_string += "R " + (value / 10).toFixed(1);
    }
    else if (value > 0) 
    {
        balance_string += "L " + (-value /10).toFixed(1);
    }
    else if (value === 0) 
    {
        balance_string += "Center";
    }
    
    return balance_string;


};

//This should mirror the GetMasterVolumeString function in preampsettings.cpp
function getMasterVolumeString(element, vol) {
    var rtn = ""
     if (vol === element.attr('min')) {
       rtn +=  "INF";
    }
    else {
        rtn +=  vol + " dB";
    }
    return rtn;



};



setTimeout(UpdatePage, 500);
